%right now rebalancing every day
%rebalancing in different increments
%read # outstanding shares from Yahoo?
%plot on same graph, axis with dates

%daily: [0.0014 0.0118 0.0014 0.0150 0.0063 0.0040 0.0078 0.0084 3.8784e-04]

%A=xlsread('Stocks.xlsx',1,'A2:I200');
portfolio={'YHOO','MSFT','RAD','BAC','ORCL','FB','SIRI','AAPL','BTU'};
sDate='01/01/2009';
eDate='01/01/2015';
dates=busdays(sDate,eDate,'daily');
datesStr=datestr(dates);
data=getYahooDailyData(portfolio,sDate,eDate, 'dd/mm/yyyy');
%rebalancing
prevRebalance=1;
adjClose=zeros(length(dates),length(portfolio));

% for z=1:length(struct2cell(data))
%     dp=data.(portfolio{z});
%     adjClose(1:length(dates),z)=table2array(dp(1:length(dates),7));
% end

for z=1:length(struct2cell(data))
    dp=data.(portfolio{z});
    if height(dp)~=length(dates)
        difference=length(dates)-height(dp);
        adjClose(1:difference,z)=ones(1,difference)*table2array(dp(1,7));
        adjClose(difference+1:length(dates),z)=table2array(dp(:,7));
    else
        adjClose(:,z)=table2array(dp(1:length(dates),7));
    end
end

sharesOutstanding=xlsread('Stocks.xlsx',2,'A2:I2');
sharesOutstanding=sharesOutstanding.'/1e11;

[m,n]=size(adjClose);
adjClose(m,:)=1;
for i=1:n
    for j=1:m
        marketCap(j,i)=adjClose(j,i).*sharesOutstanding(i);
    end
end

for k=1:m
    sumMarketCap(k,1)=sum(marketCap(k,:));
    oneInEach(k,1)=sum(adjClose(k,:));
end
sumEqualValue=struct('daily',zeros(m-1,1),'monthly',zeros(m-1,1),'quarterly',zeros(m-1,1),'weekly',zeros(m-1,1));
sumMarketValue=struct('daily',zeros(m-1,1),'monthly',zeros(m-1,1),'quarterly',zeros(m-1,1),'weekly',zeros(m-1,1));
sumOneinEach=struct('daily',zeros(m-1,1),'monthly',zeros(m-1,1),'quarterly',zeros(m-1,1),'weekly',zeros(m-1,1));

sharesInStockEqualValue=struct('daily',[],'monthly',[],'quarterly',[],'weekly',[]);
sharesInStockMarketCap=struct('daily',[],'monthly',[],'quarterly',[],'weekly',[]);
sharesInStockOneinEach=struct('daily',[],'monthly',[],'quarterly',[],'weekly',[]);
for date=1:m-1
    if date==1
        totalValueMarketCap=1;
        totalValueEqualValue=1;
        totalValueOneinEach=1;
        for stock=1:n
            percentComp(date,stock)=marketCap(date,stock)./sumMarketCap(date);   
            sharesInStockEqualValue.daily(date,stock)=(1/n)*totalValueEqualValue./adjClose(date,stock);
            sharesInStockEqualValue.monthly(date,stock)=(1/n)*totalValueEqualValue./adjClose(date,stock);
            sharesInStockEqualValue.quarterly(date,stock)=(1/n)*totalValueEqualValue./adjClose(date,stock);
            sharesInStockEqualValue.weekly(date,stock)=(1/n)*totalValueEqualValue./adjClose(date,stock);
            sharesInStockMarketCap.daily(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
            sharesInStockMarketCap.monthly(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
            sharesInStockMarketCap.quarterly(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
            sharesInStockMarketCap.weekly(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
            sharesInStockOneinEach.daily(date,stock)=1/sum(adjClose(1,:));
            sharesInStockOneinEach.monthly(date,stock)=1/sum(adjClose(1,:));
            sharesInStockOneinEach.quarterly(date,stock)=1/sum(adjClose(1,:));
            sharesInStockOneinEach.weekly(date,stock)=1/sum(adjClose(1,:));
        end
    else
        [sharesInStockEqualValue.monthly, sharesInStockMarketCap.monthly, sharesInStockOneinEach.monthly] = rebalance_monthly(n,n,date,...
            dates,adjClose,marketCap,sumMarketCap, sharesInStockEqualValue.monthly,...
            sharesInStockMarketCap.monthly,sharesInStockOneinEach.monthly);
        [sharesInStockEqualValue.quarterly, sharesInStockMarketCap.quarterly, sharesInStockOneinEach.quarterly] = rebalance_3monthly(n,n,prevRebalance,...
            date,dates,adjClose,marketCap,sumMarketCap,sharesInStockEqualValue.quarterly,...
            sharesInStockMarketCap.quarterly,sharesInStockOneinEach.quarterly);
        [sharesInStockEqualValue.weekly, sharesInStockMarketCap.weekly, sharesInStockOneinEach.weekly] = rebalance_weekly(n,n,date,...
            dates,adjClose,marketCap,sumMarketCap,sharesInStockEqualValue.weekly,...
            sharesInStockMarketCap.weekly,sharesInStockOneinEach.weekly);
        [sharesInStockEqualValue.daily, sharesInStockMarketCap.daily, sharesInStockOneinEach.daily] = rebalance_daily(n,n,date,...
            adjClose,marketCap,sumMarketCap,sharesInStockEqualValue.daily,...
            sharesInStockMarketCap.daily,sharesInStockOneinEach.daily);
    end
    
    sumEqualValue.monthly(date)=sum(sharesInStockEqualValue.monthly(date,:).*adjClose(date,:));
    sumMarketValue.monthly(date)=sum(sharesInStockMarketCap.monthly(date,:).*adjClose(date,:));
    sumOneinEach.monthly(date)=sum(sharesInStockOneinEach.monthly(date,:).*adjClose(date,:));
    sumEqualValue.quarterly(date)=sum(sharesInStockEqualValue.quarterly(date,:).*adjClose(date,:));
    sumMarketValue.quarterly(date)=sum(sharesInStockMarketCap.quarterly(date,:).*adjClose(date,:));
    sumOneinEach.quarterly(date)=sum(sharesInStockOneinEach.quarterly(date,:).*adjClose(date,:));
    sumEqualValue.weekly(date)=sum(sharesInStockEqualValue.weekly(date,:).*adjClose(date,:));
    sumMarketValue.weekly(date)=sum(sharesInStockMarketCap.weekly(date,:).*adjClose(date,:));
    sumOneinEach.weekly(date)=sum(sharesInStockOneinEach.weekly(date,:).*adjClose(date,:));
    sumEqualValue.daily(date)=sum(sharesInStockEqualValue.daily(date,:).*adjClose(date,:));
    sumMarketValue.daily(date)=sum(sharesInStockMarketCap.daily(date,:).*adjClose(date,:));
    sumOneinEach.daily(date)=sum(sharesInStockOneinEach.daily(date,:).*adjClose(date,:));
end

datesMinusOne=dates(1:length(dates)-1);

figure
plot(datesMinusOne,sumEqualValue.daily(:),'g')
hold on
plot(datesMinusOne,sumEqualValue.weekly(:),'r')
hold on
plot(datesMinusOne,sumEqualValue.monthly(:),'b')
hold on
plot(datesMinusOne,sumEqualValue.quarterly(:),'k')
title('Equal Value')
datetick('x',11)
legend('daily','weekly','monthly','quarterly','Location','northwest')

figure;
plot(datesMinusOne,sumMarketValue.monthly(:),'k')
hold on
plot(datesMinusOne,sumMarketValue.quarterly(:),'r')
hold on
plot(datesMinusOne,sumMarketValue.weekly(:),'b')
hold on
plot(datesMinusOne,sumMarketValue.daily(:),'g')
title('Market Cap Value')
datetick('x',11)
legend('daily','weekly','monthly','quarterly','Location','northwest')

% subplot(2,2,2)
% plot(datesMinusOne,sumMarketValue.monthly(:),'k')
% hold on
% plot(datesMinusOne,sumMarketValue.quarterly(:),'r')
% hold on
% plot(datesMinusOne,sumMarketValue.weekly(:),'b')
% hold on
% plot(datesMinusOne,sumMarketValue.daily(:),'g')
% title('Market Value')
% datetick('x',11)
% 
% subplot(2,2,3)
% plot(datesMinusOne,sumOneinEach.monthly(:),'k')
% hold on
% plot(datesMinusOne,sumOneinEach.quarterly(:),'r')
% hold on
% plot(datesMinusOne,sumOneinEach.weekly(:),'b')
% hold on
% plot(datesMinusOne,sumOneinEach.daily(:),'g')
% title('One in Each')
% datetick('x',11)
% % legend('monthly','quarterly','weekly','daily')
% 
% figure(2);
% subplot(2,2,1)
% plot(datesMinusOne,sumEqualValue.daily(:),'k')
% hold on
% plot(datesMinusOne,sumMarketValue.daily(:),'r')
% hold on
% plot(datesMinusOne,sumOneinEach.daily(:),'b')
% title('Daily Rebalance')
% datetick('x',11)
% 
% subplot(2,2,2)
% plot(datesMinusOne,sumEqualValue.weekly(:),'k')
% hold on
% plot(datesMinusOne,sumMarketValue.weekly(:),'r')
% hold on
% plot(datesMinusOne,sumOneinEach.weekly(:),'b')
% title('Weekly Rebalance')
% datetick('x',11)
% 
% subplot(2,2,3)
% plot(datesMinusOne,sumEqualValue.monthly(:),'k')
% hold on
% plot(datesMinusOne,sumMarketValue.monthly(:),'r')
% hold on
% plot(datesMinusOne,sumOneinEach.monthly(:),'b')
% title('Monthly Rebalance')
% datetick('x',11)
% 
% subplot(2,2,4)
% plot(datesMinusOne,sumEqualValue.quarterly(:),'k')
% hold on
% plot(datesMinusOne,sumMarketValue.quarterly(:),'r')
% hold on
% plot(datesMinusOne,sumOneinEach.quarterly(:),'b')
% title('Quarterly Rebalance')
% datetick('x',11)
% % legend('Equal Value Portfolio', 'Market Value Portfolio', 'One in Each Portfolio')
